/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef LIB_APSH_GLIB_COMPAT_H
#define LIB_APSH_GLIB_COMPAT_H

static inline gboolean
g_hash_table_insert_compat(GHashTable *table, gpointer key, gpointer value)
{
#if !GLIB_CHECK_VERSION(2, 39, 0)
	g_hash_table_insert(table, key, value);
	return true;
#else
	return g_hash_table_insert(table, key, value);
#endif
}

#if !GLIB_CHECK_VERSION(2, 22, 0)

static guint
g_int64_hash(gconstpointer v)
{
	return (guint) * (const gint64 *)v;
}

static gboolean
g_int64_equal(gconstpointer v1, gconstpointer v2)
{
	return *((const gint64 *)v1) == *((const gint64 *)v2);
}

#endif

#endif
