/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include "apsh_instance.h"

status_t
os_destroy(apsh_instance_t apsh)
{
	status_t status = APSH_S;

	if (apsh->os_interface == NULL) {
		print_error("APSH_ERROR: No OS initialized\n");
		status = APSH_F;
	} else if (apsh->os_interface->os_teardown != NULL) {
		status = apsh->os_interface->os_teardown(apsh);
	}

	if (apsh->os_interface != NULL)
		free(apsh->os_interface);

	apsh->os_interface = NULL;

	if (apsh->os_data != NULL)
		free(apsh->os_data);

	apsh->os_data = NULL;

	return status;
}
