/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __PLUGIN_CONTEXT_H__
#define __PLUGIN_CONTEXT_H__

#include <glib.h>

struct plugin_context {
	void *context;
	void (*destroy_ptr)(void *ptr);
};

enum apsh_plugin_contexts {
	PLUGIN_HASHTEST,
	PLUGIN_LIBS,
	PLUGIN_MODULES,
	PLUGIN_VMA,
	PLUGIN_EPROCESS,
	PLUGIN_DLL_EXPORTS,
	PLUGIN_DLL_LIST,
	PLUGIN_THREAD_SEEN_STACK,
	PLUGIN_THREAD_ENTRY,
	PLUGIN_HANDLES,
};

void
plugin_ctx_destroy(struct plugin_context *ctx);

int
plugin_ctx_insert(GHashTable *plugin_table, enum apsh_plugin_contexts plugin_key, void *context, void (*destroy_ptr)(void *));

void *
plugin_ctx_lookup(GHashTable *plugin_table, enum apsh_plugin_contexts plugin_key);

#endif /* __PLUGIN_CONTEXT_H__ */