/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef LIB_APSH_JSON_PROFILES_H
#define LIB_APSH_JSON_PROFILES_H

#ifdef ENABLE_JSON_PROFILES
#define APSH_EXTRA_JSON

#include <json-c/json.h>
#include "apsh_instance.h"
#include "profile_of_file_json/rekall.h"
#include "profile_of_file_json/volatility_ist.h"

typedef struct json_interface {
    const char *path; /**< JSON profile's path for domain's running kernel */

    json_object *root;

    status_t (*handler)(
        json_object *json,
        const char *symbol,
        const char *subsymbol,
        addr_t *rva,
        size_t *size);

    status_t
    (*bitfield_offset_and_size)(
        json_object *json,
        const char *symbol,
        const char *subsymbol,
        addr_t *rva,
        size_t *start_bit,
        size_t *end_bit);

    const char* (*get_os_type)(
        apsh_instance_t apsh);
} json_interface_t;

bool json_profile_init(apsh_instance_t apsh, const char* path);

#endif
#endif /* LIB_APSH_JSON_PROFILES_H */
