/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __LIB_REGEXOOB_H__
#define __LIB_REGEXOOB_H__

#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <stdio.h>
#include <inttypes.h>
#include <unistd.h>
#include <doca_mema.h>

#include <apsh_const.h>

typedef struct _REGEXOOB_RESULT {
	uint64_t phy_add;
	uint32_t len;
	int rule_id;
	struct _REGEXOOB_RESULT *next;
} regexoob_result_t;

struct regexoob_ctx;
typedef struct regexoob_ctx *regexoob_ctx_t;

status_t
regexoob_init(uint8_t *rules_buffer, size_t rules_buffer_len, struct doca_dev_rep *host_rep, struct doca_dev *regex_dev, const char *mem_regions, regexoob_ctx_t *regex_oob);

status_t
regexoob_scan(regexoob_ctx_t regex_oob, uint64_t start_phy_add, uint32_t len, regexoob_result_t **regex_result);

void
regexoob_destroy(regexoob_ctx_t regex_oob);

void
regexoob_result_destroy(regexoob_result_t *regex_result);


#endif
