/*
 * Copyright (c) 2021-2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __LINUX_MODULES_H__
#define __LINUX_MODULES_H__

#include "vmm.h"
#include "jsonout.h"

typedef struct LINUX_MODULE_LIST
{
    addr_t entry;
    char* name;
    uint32_t size;
    GHashTable* data;
    struct LINUX_MODULE_LIST *next;
} linux_module_list_t;

status_t linux_modules(apsh_instance_t apsh, json_object **json_obj, bool printout);

status_t linux_get_modules(apsh_instance_t apsh, linux_module_list_t **modules_list);

void linux_free_module_list(linux_module_list_t *modules_list);

#endif /* __LINUX_MODULES_H__ */
