/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */
#ifndef __WINDOWS_MODULES_H__
#define __WINDOWS_MODULES_H__

#include "vmm.h"
#include "jsonout.h"

typedef struct _WINDOWS_MODULE_LIST
{
    addr_t entry;
    GHashTable* hash;
    struct _WINDOWS_MODULE_LIST *next;
} windows_module_list_t;

status_t windows_save_kernel_exports(apsh_instance_t apsh);

status_t windows_modules(apsh_instance_t apsh, json_object **json_obj, bool printout);

status_t windows_modules_inloadlist(apsh_instance_t apsh, windows_module_list_t **modules_list);

void windows_free_module_list(windows_module_list_t *modules_list);

#endif /* __WINDOWS_MODULES_H__ */
