/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */


#ifndef __PRIVS_H__
#define __PRIVS_H__

#include <stdbool.h>
#include <stdint.h>

#include "vmm.h"
#include "jsonout.h"
#include "pslist.h"

typedef struct _WINDOWS_PRIVILEGE_LIST {
	char *name;
	uint32_t pid;
	char *procname;
	bool is_on;
	bool present;
	bool enabled;
	bool enabled_by_default;
	GHashTable *hash;
	struct _WINDOWS_PRIVILEGE_LIST *next;
} windows_privileges_list_t;

status_t privs(apsh_instance_t apsh, windows_processes_list_t *process_list, uint32_t pid, windows_privileges_list_t **privileges_list);

void windows_free_privileges_list(windows_privileges_list_t *priv_list);

#endif /* __PRIVS_H__ */
