/*
 * Copyright (c) 2021-2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __WINDOWS_THREADLIST_H__
#define __WINDOWS_THREADLIST_H__

#include "vmm.h"
#include "pslist.h"

typedef struct _WINDOWS_THREAD_LIST
{
    uint32_t pid;
    uint32_t tid;
    addr_t address;
    GHashTable* hash;
    struct _WINDOWS_THREAD_LIST *next;
} windows_thread_list_t;

status_t windows_threadlist(apsh_instance_t apsh, windows_processes_list_t *process_list, uint32_t pid, json_object **json_obj, bool printout, bool monitor_mode);

status_t windows_get_threadlist(apsh_instance_t apsh, windows_processes_list_t *process_list, uint32_t pid, windows_thread_list_t** thread_list);

void windows_free_thread_list(windows_thread_list_t *thread_list);

#endif /* __WINDOWS_THREADLIST_H__ */
