/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef GRPC_TYPE_CONVERTER_H_
#define GRPC_TYPE_CONVERTER_H_

#include <string>

#include <rte_mbuf.h>

#include "doca_dpi.h"
#include "doca_dpi.pb.h"

#ifdef __cplusplus
extern "C" {
#endif

void converter_init(struct rte_mempool *mp, uint16_t data_buffer_size_in_mbuf);
void *convert_grpc_user_data(const std::string &user_data);
void free_user_data(void *converted_user_data);
DocaDpiResult *convert_result(const struct doca_dpi_result *src);
DocaDpiGenericPacket *convert_rte_mbuf(const struct rte_mbuf *src);
struct rte_mbuf *convert_grpc_generic_packet(const DocaDpiGenericPacket *src);
DocaDpiSigData *convert_sig_data(const struct doca_dpi_sig_data *src, DocaDpiSigData *buff = NULL);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* GRPC_TYPE_CONVERTER_H_ */
