/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef SYNC_MAP_H_
#define SYNC_MAP_H_

#include <map>
#include <mutex>
#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

struct sync_map {
	std::mutex lock;
	std::map<uint64_t, void *> hash_table;
};

void sync_map_add(struct sync_map *obj, uint64_t key, void *value);
void *sync_map_remove(struct sync_map *obj, uint64_t key);
void *sync_map_get(struct sync_map *obj, uint64_t key);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* SYNC_MAP_H_ */
