/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DNS_PARSER_H_
#define DNS_PARSER_H_

#include "base_parser.h"

#ifdef __cplusplus
extern "C" {
#endif

struct dns_cache;

/**
 * Update DNS cache with context information
 *
 * @param pctx
 *  A pointer to parser context
 * @param cache
 *  The DNS cache to add the information to.
 * @param sig_id
 *  sig id
 * @return
 *   - 0 on success, error code otherwise
 */
int
dns_parser_cache_update(struct rte_mbuf *mbuf, uint32_t payload_offset,
			const struct dns_cache *cache, int sig_id);

/**
 * Creates DNS parser
 */
struct dpi_parser *dns_parser_get(void);

#ifdef __cplusplus
}
#endif

#endif /* DNS_PARSER_H_ */
