/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

/**
 * @file
 *
 * SSL parser
 *
 * The SSL parser tracks SSL certificate exchange To identify the following fields:
 * ClientHello->server_name
 * Certificate->certificate->common_name
 * NewTicket
 *
 * On tls resumption:
 * ClientHello->sessionID + ServerHello->sessionID
 * ClientHello->Ticket
 *
 */
#ifndef SSL_PARSER_H_
#define SSL_PARSER_H_

#include <stdint.h>

#include <rte_mbuf.h>

#include "base_parser.h"

#ifdef __cplusplus
extern "C" {
#endif

struct dpi_parser *ssl_parser_get(void);

#ifdef __cplusplus
}
#endif

#endif /* SSL_PARSER_H_ */
