/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef STREAM_PARSER_H_
#define STREAM_PARSER_H_

#include "base_parser.h"

#ifdef __cplusplus
extern "C" {
#endif

struct dpi_parser *tcp_parser_get(void);
struct dpi_parser *udp_parser_get(void);
struct dpi_parser *other_l4_protocol_parser_get(void);

void stream_parser_set_max_sig_len(uint16_t len);

#ifdef __cplusplus
}
#endif

#endif /* STREAM_PARSER_H_ */
