/*
 * Copyright (c) 2021-2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef LIBS_DOCA_REGEX_IMPL_DRIVERS_BF_BF2_REGEX_HEADERS_H_
#define LIBS_DOCA_REGEX_IMPL_DRIVERS_BF_BF2_REGEX_HEADERS_H_

#include <doca_build_config.h>

#ifdef DOCA_ARCH_ARM
static inline void
priv_prefetch0(const volatile void *p)
{
	asm volatile("PRFM PLDL1KEEP, [%0]" : : "r"(p));
}
#else /* !DOCA_ARCH_ARM */
static inline void
priv_prefetch0(const volatile void *p)
{
	asm volatile("prefetcht0 %[p]" : : [p] "m"(*(const volatile char *)p));
}

#endif /* DOCA_ARCH_ARM */

#endif /* LIBS_DOCA_REGEX_IMPL_DRIVERS_BF_BF2_REGEX_HEADERS_H_ */
