/*
 * Copyright (c) 2021-2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __COMMON_COMPILER_HPP__
#define __COMMON_COMPILER_HPP__

#include <stdio.h>

#include <doca_argp.h>

#include <doca_error.h>

#define MAX_FILE_NAME 255

enum format_type {
	INVALID,
	SURICATA,
	QOSMOS
};

struct in_args {
	char input_file[MAX_FILE_NAME]; /* name for the suricata rules file */
	char cdo_file_name[MAX_FILE_NAME]; /* name for the CDO file */
	char classtype_file[MAX_FILE_NAME]; /* name for the input classtype file */
	format_type rules_format; /* input file rules format */
};

doca_error_t register_dpi_compiler_params(void);

#endif /* __COMMON_COMPILER_HPP__ */
