/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __DOCA_DPI_SURICATA_PARSER_UTILS_HPP__
#define __DOCA_DPI_SURICATA_PARSER_UTILS_HPP__

#include "dpi_suricata_parser.hpp"
#include "dpi_compiler.hpp"
#include <string.h>
#include <list>

void init_sig_header(void);
char *content_converter(const char *content);
int pcre_converter(const char *pcre, struct doca_dpi_rule *rule);
void initiate_rule(struct doca_dpi_rule *rule);
int update_compiler(doca_dpi_compiler *ctx, std::list < struct doca_dpi_rule > *rules_list);
void init_sig_global_options(void);

#endif /* __DOCA_DPI_SURICATA_PARSER_UTILS_HPP__ */
